// Rule.h: interface for the CRule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RULE_H__49302B08_2C8D_49F8_A9F5_BFD07A27BC7D__INCLUDED_)
#define AFX_RULE_H__49302B08_2C8D_49F8_A9F5_BFD07A27BC7D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ruleparser.h"

typedef vector<CCondition> TConditionVector;
typedef vector<CCondition>::iterator TConditionVectorIterator;

typedef	vector<CAction> TActionVector;
typedef	vector<CAction>::iterator TActionVectorIterator;

class CRule : public IXMLNode  
{
public:
	TActionVector* Evaluate( CQuery& query );
	CRule(CRuleEngine* parent);
	virtual ~CRule();

	virtual bool set_XML( IXMLDOMNodePtr e );
	string Name() { return m_Name; };

	TConditionVector& conditions() { return m_conds; };
	TActionVector& actions() { return m_actions; };

private:
	string m_Name;
	CRuleEngine* m_Parent;
	TConditionVector m_conds;
	TActionVector m_actions;
};

#endif // !defined(AFX_RULE_H__49302B08_2C8D_49F8_A9F5_BFD07A27BC7D__INCLUDED_)
