/*!
  \file RuleEngine.cpp
  \brief Implementuje triedu CRuleEngine  
	 Zakladna trieda RuleParser-a	 
  \author Rado Kostelnik
  \date	26-11-2001
  \version 1.0.0.0

  \bug
  \warning
*/

// Rules.cpp: implementation of the CRules class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ruleparser.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRuleEngine::CRuleEngine()
{

}

CRuleEngine::~CRuleEngine()
{
	m_rules.erase( m_rules.begin(), m_rules.end() );
}

bool CRuleEngine::loadXML( string sFileName )
{
	IXMLDOMDocumentPtr dom;
	IXMLDOMNodePtr e;
	_bstr_t s;
	_variant_t filename;
	_variant_t retval((bool) true);

	IXMLDOMNodeListPtr l;
	IXMLDOMElementPtr el;

	dom.CreateInstance( "MSXML2.DOMDocument.3.0" );

	s = sFileName.c_str();
	filename.vt = VT_BSTR;
	filename.bstrVal = s;

	retval = dom->load( filename );
	
	if ( (bool)retval == false )
		return false;

	e = dom->documentElement;

	l = e->selectNodes( L"rule" );

	l->reset();

	el = l->nextNode(); 

	while ( el )
	{
		CRule *r = new CRule( this );
		r->set_XML ( el );
		m_rules.push_back( *r );

		el = l->nextNode(); 
	}

	e.Release();

	return true;
}

TRuleVector* CRuleEngine::GetRulesByName(string sName)
{
	TRuleVectorIterator ri = m_rules.begin();
	TRuleVectorIterator re = m_rules.end();
	TRuleVector* rules = new TRuleVector;

	for ( ; ri != re; ri ++ )
	{
		CRule& r = *ri;
		if ( r.Name() == sName )
			rules->push_back( r );
	}

	return rules;
}

TActionVector* CRuleEngine::Evaluate(string sRuleName, CQuery &query)
{
	TRuleVectorIterator ri = m_rules.begin();
	TRuleVectorIterator re = m_rules.end();
	TActionVector* retval = NULL;

	for ( ; ri != re; ri++ )
	{
		CRule& r = *ri;
		if ( r.Name() == sRuleName )
		{
			retval = r.Evaluate( query );
			if ( retval )
				return retval;
		}

	}

	return retval;
}
